if not (hcombi) then
	print("\x88".."--------------------------------------------------------")
	print("\x89".."Haya's Combi Ring has successfully been loaded!")
	print("\x88".."Version: Flora (1.1)")
	print("")
	print("\x8C".."Please contact haya_#7447 on Discord about bugs/problems.")
	print("\x88".."--------------------------------------------------------")
else
	print("\x82".."NOTE: Haya's Combi Ring is already loaded.")
	print("\x82".."There may be conflicting resources. Double check your mod folder.")
end

rawset(_G, "hcombi", {}) -- hcombi global namespace
hcombi.version = "v1.1.0" -- version to use on first time print
hcombi.notes = "Flora" -- thanks to peple at kru for giving me more motivation to work on this
hcombi.random = {}
hcombi.cvarprefix = "combi_"
hcombi.cvarvarprefix = "cv_"

hcombi.com = 0
hcombi.comtbl = {}

-- simple way of making a cvar
rawset(_G, "applyCombiCvar", function(name, default, typeo, internalname, usage, shortDesc, longDesc)
	internalname = internalname or name
	usage = usage or "<Unknown>" -- HE SAYS HE DOESNT KNOW!
	shortDesc = shortDesc or "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Suspendisse laoreet." -- self explanatory
	local realtype = typeo or CV_OnOff
	if typeo == "ringbit" then -- to lazy
		realtype = {MIN = 2, MAX = 64}
	end
	rawset(hcombi, hcombi.cvarvarprefix + internalname, CV_RegisterVar({hcombi.cvarprefix + name, default, CV_NETVAR, realtype}))
	hcombi.comtbl[hcombi.cvarprefix + name] = {usage, shortDesc, longDesc or shortDesc, rawget(hcombi, hcombi.cvarvarprefix + internalname)}
	hcombi.com = $ + 1
end)

-- simple way of making a command
rawset(_G, "applyCombiCmd", function(name, usage, shortDesc, longDesc, handler, flags)
	local commandName = hcombi.cvarprefix + name
    hcombi.comtbl[commandName] = {usage, shortDesc, longDesc, handler}
    hcombi.com = $ + 1
	COM_AddCommand(
        commandName,
        function(player, ...)
            handler(player, CONS_Printf, ...)
        end,
        flags or 0
    )
end)

-- define all of em
applyCombiCvar("active", "On", CV_OnOff, "combi", "<Off|On>", "Is it really worth it?")
applyCombiCvar("teleportspoof", 700, CV_Natural, nil, "<Number>", "How much distance will a player immediately teleport back to their partner.")
applyCombiCvar("pull", FRACUNIT, CV_Natural, "combipull", "<fixed_t>", "How much weight will a player pull their partner.")
applyCombiCvar("maxdistance", 450, CV_Natural, "combidist", "<Number>", "How much distance will a player and their partner be apart.")
applyCombiCvar("useoldalgorithm", "Off", CV_OnOff, nil, "<Off|On>", "Use the old partner algorithm for assigning partners.")
applyCombiCvar("ringamount", 6, "ringbit", nil, "<Number>", "How many ringbits are shown between players. Limited to 2-64.")
applyCombiCvar("tugrespawn", "On", CV_OnOff, nil, "<Off|On>", "Should players respawning pull their partner?")
applyCombiCvar("allowfriends", "On", CV_OnOff, "combifriends", "<Off|On>", "Allow players to select their partners?")

local LIST_PAGE_SIZE = 10

hcombi.RandomQuotes = {
	"combi ring maybe??????",
	"Jartbox",
	"i forgor :skull:",
	"Combi Ring",
	"j.",
	"Press F1 For",
	"Evangelion Command Prompt"
}

hcombi.RandomQuotesError = {
	"Command not recognized!",
	"DUMB FUCK",
	"Did you know? [Hyperlink Blocked].",
	"ring racer will never be real",
	"*spitting*",
	"but......but......... p!!!!!!!!",
	"NO."
}

applyCombiCmd(
    "help",
    "[page|command]",
    "The command you're using!",
    "Displays commands or more information about a command.\n"
        + "\tpage: The page of commands to display\n"
        + "\tcommand: The command about which to displaye more information",
    function(player, printHandle, var1)
        var1 = $ == nil and "1" or $
        local page = tonumber(var1)
        if page == nil then
            local command = var1:lower():sub(1, 6) == hcombi.cvarprefix and var1
                or hcombi.cvarprefix + var1
            if hcombi.comtbl[command] then
                printHandle(
                    player,
                    string.format(
                        hcombi.RandomQuotes[(leveltime % table.maxn(hcombi.RandomQuotes))+1] + " Help (%s)\n%s%s\n%s",
                        command,
                        "\130"+command+"\132",
                        hcombi.comtbl[command][1] and " " + hcombi.comtbl[command][1]+"\128" or ""+"\128",
                        hcombi.comtbl[command][3] or hcombi.comtbl[command][2]
                    )
                )
            else
                printHandle(player, "\130"+hcombi.RandomQuotesError[(leveltime % table.maxn(hcombi.RandomQuotesError))+1])
            end
        else
            local maxPage = (hcombi.com - 1) / LIST_PAGE_SIZE + 1
            if page > 0 and page <= maxPage then
                printHandle(player, hcombi.RandomQuotes[(leveltime % table.maxn(hcombi.RandomQuotes))+1] + " Help (Page " + page + "/" + maxPage + ")")
                local i = 1
                local startpoint = page * LIST_PAGE_SIZE - LIST_PAGE_SIZE + 1
                local breakpoint = page * LIST_PAGE_SIZE
                for command, info in pairs(hcombi.comtbl) do
                    if i >= startpoint then
						--printHandle(player, command)
                        printHandle(
                            player,
                            string.format(
                                "%s%s: %s",
                                "\130"+command+"\132",
                                info[1] and " " + info[1]+"\128" or ""+"\128",
                                info[2]
                            )
                        )
                    end
                    i = $ + 1
                    if i > breakpoint then
                        break
                    end
                end
            else
                printHandle(player, "\x82Page number out of range (1-" + maxPage + ")!")
            end
        end
    end
)

/*
hcombi.cv_combi = CV_RegisterVar({"combi_active", "On", CV_NETVAR, CV_OnOff})
hcombi.cv_teleportspoof = CV_RegisterVar({"combi_teleportspoof", 700, CV_NETVAR, CV_Natural}) 
hcombi.cv_combipull = CV_RegisterVar({"combi_pull", FRACUNIT, CV_NETVAR, CV_Natural})
hcombi.cv_combidist = CV_RegisterVar({"combi_maxdistance", 450, CV_NETVAR, CV_Natural})
hcombi.cv_useoldalgorithm = CV_RegisterVar({"combi_useoldalgorithm", "Off", CV_NETVAR, CV_OnOff})
hcombi.cv_ringjitter = CV_RegisterVar({"combi_ringjitter", "Off", CV_NETVAR, CV_OnOff})
hcombi.cv_ringamount = CV_RegisterVar({"combi_ringamount", 6, CV_NETVAR, CV_Natural})
hcombi.cv_tugrespawn = CV_RegisterVar({"combi_tugrespawn", "On", CV_NETVAR, CV_OnOff})
*/

-- 1.5 wrappers so that its still compatible with 1.3
hcombi.P_GetDistance = function(x,y) return FixedHypot(x,y) end 
hcombi.P_TeleportMobj = function(mobj,x,y,z) if P_MoveOrigin ~= nil then return P_SetOrigin(mobj, x, y, z) end return P_TeleportMove(mobj, x, y, z) end 
hcombi.P_MoveMobj = function(mobj,x,y,z) if P_MoveOrigin ~= nil then return P_MoveOrigin(mobj, x, y, z) end return P_TeleportMove(mobj, x, y, z) end 

-- see ringbit.lua for more details.
hcombi.combi_initscroll = 0

-- to prevent desyncs, we will be using a different random function
-- this is desync proof, so everything will be synced on a replay.
-- all bit shift fuckery gets saved on this cvar after every map change.
-- cvar gets saved on the start of a replay
-- game reads cvar on mapload
hcombi.random.__internal_cvar = CV_RegisterVar({
    name = "__combi_random_cv",
    defaultvalue = "0/6278/975/39207/45678",
    flags = CV_NETVAR,
    possiblevalue = nil
})

-- funny numbers
hcombi.random.t = 0
hcombi.random.x = 6278
hcombi.random.y = 975
hcombi.random.z = 39207
hcombi.random.w = 45678
-- evil bit shift fuckery
hcombi.random.random = function()
    hcombi.random.t = hcombi.random.x ^^ (hcombi.random.x << 11)
    hcombi.random.x, hcombi.random.y, hcombi.random.z, hcombi.random.w = hcombi.random.y, hcombi.random.z, hcombi.random.w, hcombi.random.w ^^ (hcombi.random.w >> 19) ^^ hcombi.random.t ^^ (hcombi.random.t >> 8)
    return hcombi.random.w
end
-- then we reimplement every baseline random function
hcombi.random.randomKey = function(n)
    return abs(hcombi.random.random() % n)
end
hcombi.random.randomRange = function(a, b)
    return a + abs(hcombi.random.random() % (b - a + 1))
end
hcombi.random.data = function()
    return d
end
hcombi.random.__setcvar = function()
    COM_BufInsertText(server, '__combi_random_cv "'+hcombi.random.t+"/"+hcombi.random.x+"/"+hcombi.random.y+"/"+hcombi.random.z+"/"+hcombi.random.w+'"')
end
-- deserlialize prng state from a cvar so that replays sync
hcombi.random.__getcvar = function()
    local t = {}
    for str in string.gmatch(hcombi.random.__internal_cvar.string, "([^\/]+)") do
        table.insert(t, str)
    end
    hcombi.random.t = t[1]
    hcombi.random.x = t[2]
    hcombi.random.y = t[3]
    hcombi.random.z = t[4]
    hcombi.random.w = t[5]
end