-- reimplement combi ring cirl

local ring_bits = {}
local ring_bits_count = 0

hcombi.Chains = {}

-- STOLEN FROM 4CHAN V2 TETHER
-- THANKS FOR THE CODE BITCHES
local function makehcombiChain(p, bits)
	if (hcombi.Chains[p.name])
		return; // you ALREADY have a chain
	end
	
	if (not (p.valid and p.mo and p.mo.valid)) then return; end // spectating or just gone
	
	hcombi.Chains[p.name] = {};
	
	for i = 1, ((bits) and (bits-1) or hcombi.cv_ringamount.value)
		if i < hcombi.cv_ringamount.value-2 and p.combi ~= nil then continue end
		local nprarkl = (i >= hcombi.cv_ringamount.value or i == 1)
		hcombi.Chains[p.name][i+1] = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z+(p.mo.height*(i+1)), MT_COMBILINK);
		hcombi.Chains[p.name][i+1].statemem = hcombi.Chains[p.name][i+1].state;
		hcombi.Chains[p.name][i+1].state = nprarkl and S_COMBILINK1 or S_COMBILINK2;
		--print(i + 1);
	end
end

local function clearChainData(p)
	for i = 1, 3 // delete objects
		if (not hcombi.Chains[p.name]) then continue; end
		if (not hcombi.Chains[p.name][i+1]) then continue; end
		
		
		if (hcombi.Chains[p.name][i+1].valid )
			P_RemoveMobj(hcombi.Chains[p.name][i+1]);
		end
		
		hcombi.Chains[p.name][i+1] = nil;
	end
	
	hcombi.Chains[p.name] = nil; // clear data 
end

local function linkhcombiChain(p, c, bits)
	local hasClosest = true;
	
	local closestDist = {};
	
	if (not hcombi.Chains[p.name])
		return; // need a chain
	end
	
	if (not (p.valid and p.mo and p.mo.valid)) then return; end // spectating or just gone
	
	local destx = p.mo.x;
	local desty = p.mo.y;
	local destz = p.mo.z;
	
	local divx = 0;
	local divy = 0;
	local divz = 0;
	local fracmul = FRACUNIT;
	
	if (not (c and c.valid)) then hasClosest = false; end // no closest player
	
	local mos = mapobjectscale;
	
	local jitter = 6;
	
	if (hasClosest)
		closestDist[1] = (c.x - p.mo.x);
		closestDist[2] = (c.y - p.mo.y);
		closestDist[3] = (c.z - p.mo.z);
		
		divx = closestDist[1]/((bits) and max(1, bits) or 1);
		divy = closestDist[2]/((bits) and max(1, bits) or 1);
		divz = closestDist[3]/((bits) and max(1, bits) or 1);
	end
	
	local xydist = 0;
	local dist3d = 0;
	
	if (closestDist[1] and closestDist[2])
		xydist = R_PointToDist2(0, 0, closestDist[1], closestDist[2]);
		dist3d = R_PointToDist2(0, 0, xydist, closestDist[3]);
	end
	
	xydist = nil; 
	
	for i = 1, ((bits) and (bits-1) or hcombi.cv_ringamount.value)
		
		if (not hcombi.Chains[p.name]) then break; end // the chain doesn't even exist, abort this entire operation
		
		if (not hcombi.Chains[p.name][i+1]) then continue; end
		if (not hcombi.Chains[p.name][i+1].valid) then clearChainData(p); continue; end // panic clear
		
		if (not hcombi.Chains[p.name][i+1].statemem) then continue; end
		
		local nprarkl = hcombi.Chains[p.name][i+1].state == S_COMBILINK1
		local scl = (mapheaderinfo[gamemap] and mapheaderinfo[gamemap].mobj_scale or FRACUNIT)
		hcombi.Chains[p.name][i+1].scale = nprarkl and scl/2 or scl

		hcombi.P_MoveMobj(hcombi.Chains[p.name][i+1], p.mo.x + (divx*i), p.mo.y + (divy*i), p.mo.z + (divz*i) + (18*mos));
		hcombi.Chains[p.name][i+1].color = p.mo.color
	end
	
	dist3d = nil;
	
	mos = nil;
end

local function drawhcombi(p)
	/*if (not p.vectorPos) then return; end
	if (not p.closest.vectorPos) then return; end
	if (p.distfromClosest and (p.distfromClosest <= (p.pullDist/6)*mapobjectscale) ) then return; end // too close
	
	
	local sparklePos = p.vectorPos;
	local endPoint = p.closest.vectorPos;
	
	sparklePos.z = $1 + hcombi.SparkleOffsetZ(P_MobjFlip(p.mo), p.mo.scale, p.mo);

	hcombi.DrawSparkleTrail(
		sparklePos, endPoint,
		p.mo.scale, p.mo.scale,
	p);
	
	sparklePos = nil;
	endPoint = nil;*/
	//if (not p.closest) then return; end
	
	if (not hcombi.Chains[p.name])
		makehcombiChain(p, hcombi.cv_ringamount.value+1);
		return;
	end
	
	linkhcombiChain(p, p.combi_p.mo, hcombi.cv_ringamount.value+1);
end

hcombi.PlaceRingBit = function(player)
	--if player == nil or not player.valid or player.mo == nil then return end
	--if p.combi_p == nil or not p.combi_p.valid or p.combi_p.mo == nil then return end
	drawhcombi(player)
end

hcombi.RefreshRingBit = function(player)
	--if player == nil or not player.valid or player.mo == nil then return end
	--if p.combi_p == nil or not p.combi_p.valid or p.combi_p.mo == nil then return end
	clearChainData(player)
	drawhcombi(player)
end

hcombi.RemoveRingBit = function(player)
	--if player == nil or not player.valid or player.mo == nil then return end
	--if p.combi_p == nil or not p.combi_p.valid or p.combi_p.mo == nil then return end
	clearChainData(player)
end
