-- This lua file holds the thinker for assigning partners.

-- OH MY GOD THIS TOOK ME TOO LONG BRO
-- Please read the notes on the functions pls :)))))
hcombi.partnerList = {}
hcombi.loneplayernum = nil
hcombi.combi_on = false

hcombi.shuffle = function(s)
    for i = #s, 2, -1 do
        local j = hcombi.random.randomRange(1, i)
        s[i], s[j] = s[j], s[i]
    end
end

addHook("NetVars", function(sync)
	hcombi.partnerList = sync(hcombi.partnerList)
	hcombi.loneplayernum = sync(hcombi.loneplayernum)
	hcombi.combi_on = sync(hcombi.combi_on)
end)

hcombi.AllPlayers = {}

-- set partners.
addHook("ThinkFrame", function()
	-- we want 2 due to desync related issues with 0, 1, or mapload.
	if leveltime == 2 then
		hcombi.combi_on = hcombi.cv_combi.value
		if not hcombi.combi_on then
			for player in players.iterate do
				player.combi = nil
				player.combi_p = nil
			end
		
			return
		end
		-- reset our partner list
		hcombi.partnerList = {}
		
		local MAXPLAYERS = #players
		for i = 0, MAXPLAYERS-1 do
			-- make sure its a valid player
			if players[i] ~= nil then
				if players[i].mo ~= nil and players[i].mo.valid then
					table.insert(hcombi.partnerList, i)
				end
				players[i].combi = nil
				players[i].combi_p = {name = "anti-loneliness gargoyle", valid = false}
				players[i].has_partner = false
				players[i].fake_combi = players[i]
				players[i].old_combi = players[i]
				-- players[i].combi_friend = hcombi.cv_combifriends.value and hcombi.cv_combifriend[i].value or 65534
			end
		end
		
		-- no players? no problem!
		if table.maxn(hcombi.partnerList) == 0 then return end
		
		local function inArray(arr, element) -- function to check if something is in an array
			for _, value in ipairs(arr) do -- ipairs is the recommended iterator for looping through arrays
				if value == element then
					return true
				end
			end
			return false -- if no element was found, return false
		end

		local function changeDuplicates(arr)
			local newArr = {}
			for _, element in ipairs(arr) do
				while inArray(newArr, element) do -- make sure it becomes different
					element = hcombi.random.randomRange(1, #arr)
				end
				table.insert(newArr, element)
			end
			return newArr
		end
		
		local MAXPARTNERS = table.maxn(hcombi.partnerList)
		-- based on the amount of available players....
		for i = 1, MAXPARTNERS do
			-- ....shuffle the partner list.
			hcombi.shuffle(hcombi.partnerList)
		end
		
		-- change every single duplicate number to a valid number :)
		hcombi.partnerList = changeDuplicates(hcombi.partnerList)
		
		hcombi.loneplayernum = nil
		
		-- if the amount of players is odd...
		if table.maxn(hcombi.partnerList) % 2 == 1 then
			-- ...remove that player from the list.
			-- sory mate but you have to deal with the gargoyle.
			hcombi.loneplayernum = table.maxn(hcombi.partnerList)
			table.remove(hcombi.partnerList)
		end
		
		MAXPARTNERS = table.maxn(hcombi.partnerList)
		
		local function deepCopy(original)
			local copy = {}
			for k, v in pairs(original) do
				if type(v) == "table" then
					v = deepCopy(v)
				end
				copy[k] = v
			end
			return copy
		end
		
		hcombi.AllPlayers = deepCopy(hcombi.partnerList)
		
		MAXPARTNERS = table.maxn(hcombi.partnerList)
		
		--print("-- START OF PARTNER LIST --")
		--for i = 1, MAXPARTNERS do
		--	print(hcombi.partnerList[i])
		--end
		--print("-- END OF PARTNER LIST --")
		
		-- set our partners :O
		-- (old)
		if hcombi.cv_useoldalgorithm.value == 1 then
			for i = 0, MAXPARTNERS-1 do
				local realpartner = hcombi.partnerList[i+1]
				-- bitch ass better not have a partner already
				if players[realpartner].has_partner then continue end
				local nextpartner = hcombi.partnerList[i+1]
				local iterations = 0
				-- while its the same as yourself
				while nextpartner == realpartner do
					-- get a new partner
					if iterations >= 64 then break end -- make sure to break out if there are too many iterations
					nextpartner = hcombi.partnerList[hcombi.random.randomRange(1, table.maxn(hcombi.partnerList))]
					iterations = $+1
					-- if they already have a partner
					while players[nextpartner].has_partner do
						-- get another one.
						if iterations >= 64 then break end -- ditto.
						nextpartner = hcombi.partnerList[hcombi.random.randomRange(1, table.maxn(hcombi.partnerList))]
					end
				end
				-- now, lets set our partners.
				players[realpartner].combi = nextpartner
				players[nextpartner].combi = realpartner
				players[realpartner].has_partner = true
				players[nextpartner].has_partner = true
				-- move on to the next player.
			end
		end
		
		hcombi.HudPartners = deepCopy(hcombi.partnerList)
		for k,v in ipairs(hcombi.HudPartners) do
			hcombi.HudPartners[k] = players[v].name
		end
		if hcombi.loneplayernum ~= nil then
			table.insert(hcombi.HudPartners, "---")
		end
		
		for k,v in ipairs(hcombi.HudPartners) do
			--print(v)
		end
		
		-- we have reached the end of our partnering system.
		-- lets move on to the ring bit :))
	end
end)
